/*********************************************************/
/* file: obvar.c                                         */
/*                                                       */
/* Copyright (C) 1994 Karl A Holland                     */
/*                                                       */
/* author: Karl A Holland                                */
/*                                                       */
/* created:   1 november 93                              */
/*                                                       */
/* modified:  7 february 94                              */
/*                                                       */
/* contributing authors:                                 */
/*  if you add place your name here or below             */
/*                                                       */
/* description:                                          */
/*  obvar.c is an encapsulation of the calls neccesary   */
/* to change object variables 'on the fly' through the   */
/* wset and iset commands contained in command.c         */
/* of the program                                        */
/*                                                       */
/* LICENSING:                                            */
/*   a full license  is provided in the file LICENSE     */
/* which should have been included with this program when*/
/* it was copied. It may be found in the top directory   */
/* of any NORMAL distribution, named LICENSE             */
/*********************************************************/
#include <standard.h>

void
report_object(playerstruct * pl, object * ob)
{
  object         *held;
  char            tmpbuf[255],
                  tmpstring[50];

  channel_ref     *tmp_chan;
  
  write_text(pl, "----------");
  if (ob != NULL)
    {
      
      if (GET_NAME(ob) != NULL)
	{
	  sprintf(tmpbuf, "Object Name: %s", GET_NAME(ob));
	  write_text(pl, tmpbuf);
	  sprintf(tmpbuf, "Prototype: %s", GET_NAME(ob->gen_ob));
	  write_text(pl, tmpbuf);
      } 
      else
	write_text(pl, "Object has no name");
      
      sprintf(tmpbuf, "type: %s icon: %d state:%d %d %d", type_names[GET_TYPE(ob)], ob->picnum,ob->state.normal,ob->state.input,ob->state.aux);
      write_text(pl, tmpbuf);
      sprintf(tmpbuf, "color: %d",ob->color);
      write_text(pl,tmpbuf);
      sprintf(tmpbuf, "subtype: %d weight: %d", ob->subtype,GET_WEIGHT(ob));
      write_text(pl, tmpbuf);
      sprintf(tmpbuf, "Phys.: %d  MaxPhys: %d Ment.: %d  MaxMent: %d",
	      ob->attr.phys, ob->attr.physmax, ob->attr.mental,
	      ob->attr.mentmax);
      write_text(pl, tmpbuf);
      sprintf (tmpbuf,"Bulk: %d  MaxBulk:%d  Speed:%d",
	       GET_BULK(ob),GET_MAXBULK(ob),GET_SPEED(ob));
      write_text(pl,tmpbuf);
      get_obj_material(tmpstring,ob);
      sprintf(tmpbuf, "Mat'l: %s",tmpstring);
      write_text(pl,tmpbuf); 
      get_obj_resist(tmpstring,ob);
      sprintf(tmpbuf, "Resistances: %s",tmpstring);
      write_text(pl,tmpbuf); 
      get_obj_usage(tmpstring,ob);
      sprintf(tmpbuf, "Usage: %s",tmpstring);
      write_text(pl,tmpbuf);
      get_char_statbits(tmpstring, ob);
      sprintf(tmpbuf,"Statbits: %s", tmpstring);
      write_text(pl, tmpbuf);
      switch (GET_TYPE(ob))
	{
	case (null):
	  sprintf (tmpbuf,"LINKED OBJECT HEAD: %s",GET_NAME(ob->holding));
	  write_text(pl, tmpbuf);
	  sprintf (tmpbuf,"HEAD LOC x:%d y:%d z:%d"
		   ,ob->holding->x,ob->holding->y,ob->holding->z);
	  write_text(pl, tmpbuf);
	  break;
	case (animate):
	case (player):
	  sprintf(tmpbuf, "Alignment: ? Level: %d Exp. %d",
		  GET_LEVEL(ob), GET_EXP(ob));
	  write_text(pl, tmpbuf);
	  sprintf(tmpbuf, "STR:%d SMA:%d WIS:%d DEX:%d",
		  GET_STR(ob), GET_SMA(ob), GET_WIS(ob), GET_DEX(ob));
	  write_text(pl, tmpbuf);
	  sprintf(tmpbuf, "CON:%d LUK:%d LOOKS:%d CHA:%d",
		  GET_CON(ob), GET_LUK(ob), GET_LOOKS(ob), GET_CHA(ob));
	  write_text(pl, tmpbuf);
	  break;
	case (teleport):
	  sprintf(tmpbuf, "Destination:%s %d %d %d", ob->data.tecomp->mapto,
		  ob->data.tecomp->x, ob->data.tecomp->y, ob->data.tecomp->z);
	  write_text(pl, tmpbuf);
	  break;
	case (weapon):
	  sprintf(tmpbuf, "Weapon Damage: %d   Accuracy:%d%%",
		  GET_WEAP_DAM(ob), GET_WEAP_ACC(ob));
	  write_text(pl,tmpbuf);
	  get_obj_bonus(tmpstring,ob);
	  sprintf(tmpbuf,"Bonuses: %s",tmpstring);
	  write_text(pl, tmpbuf);
	  break;
	case (armour):
	  sprintf(tmpbuf,	"Armour Rating:%d   Accuracy Bonus:%d%%",
		  GET_ARMOR_VAL(ob), GET_ARM_ACC(ob));
	  write_text(pl,tmpbuf);
	  get_obj_bonus(tmpstring,ob);
	  sprintf(tmpbuf,"Bonuses: %s",tmpstring);
	  write_text(pl,tmpbuf);
	  break;
	case (door):
	  sprintf(tmpbuf,"Activation Number:%d", ob->data.docomp->keynum);
	  write_text(pl,tmpbuf);
	  break;
	default:
	  break;
	}
      if (ob->holding != NULL)
	{
	  write_text(pl, "object is holding :");
	  for (held = ob->holding; held != NULL; held = held->below)
	    {
	      sprintf(tmpbuf, "      %s", held->name);
	      write_text(pl, tmpbuf);
	    }
	}
      if (ob->message != NULL)
	{
	  write_text(pl, "Message:");
	  sprintf (tmpbuf,"     %s",ob->message->text);
	  write_text(pl,tmpbuf);
	}
      if (ob->channels != NULL)
	{
	  write_text(pl, "Channels:");
	  for (tmp_chan = ob->channels; tmp_chan != NULL;
	       tmp_chan = tmp_chan->next)
	    {
	      sprintf (tmpbuf,"     %s",tmp_chan->head->name);
	      write_text(pl,tmpbuf);
	    }
	}
  } else
    write_text(pl, "object is null");
  write_text(pl, " ");
}


void
set_dest(playerstruct * pl, object * target, char *argstring)
{
  int             k,
  v1,
  v2,
  v3;
  char            temp1[15];
  
  if (!IS_TELEPORTER(target))
    {
      write_text(pl, "cannot set that variable in non-teleporter!");
      return;
    }
  if ((k = sscanf(argstring, "%15s %d %d %d", temp1, &v1, &v2, &v3)) < 1)
    {
      write_text(pl, "no map name specified!");
      return;
    }
  if (k < 3)
    {
      v1 = v2 = 0;
      write_text(pl, "no x y coords specified, assuming origin");
    }
  if (k < 4)
    {
      v3 = 0;
      write_text(pl, "no z coord specified, assuming 0");
    }
  target->data.tecomp->x = v1;
  target->data.tecomp->y = v2;
  target->data.tecomp->z = v3;
  strcpy(target->data.tecomp->mapto, temp1);
}

void
set_name(playerstruct * pl, object * target, char *argstring)
{
  int             k;
  char            temp1[15];
  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a name");
      return;
    }
  SET_NAME(target, temp1);
  SET_PL_ITEM_CHANGED(pl);
}

void
set_statbits(playerstruct * pl, object * target, char *argstring)
{
  int k;
  char temp1[30]; 
  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a statbit string");
      return;
    }
  set_char_statbits(temp1, target);
}

void
set_bonus(playerstruct * pl, object * target, char *argstring)
{
  int k;
  char temp1[30]; 
  
  if (!IS_WEAPON(target) || !IS_ARMOUR(target))
    {
      write_text (pl,"you cannot set bonuses on non-weapons/non-armour types");
      return;
    }
  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a bonus string");
      return;
    }
  if ( target->owner == pl->obj
      && AN_OB_ITEM(pl->obj).held == target)
    {
      unequip_held (pl->obj);
      write_text (pl, "weapon unequipped to preserve integrity");
    }
  set_char_statbits(temp1, target);
}

void
set_material(playerstruct * pl, object * target, char *argstring)
{
  int k;
  char temp1[30];
  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a material string");
      return;
    }
  set_obj_material(temp1, target);
}

void
set_resist(playerstruct * pl, object * target, char *argstring)
{
  int k;
  char temp1[30];
  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a resistance string");
      return;
    }
	set_obj_resist(temp1, target);
}

void
set_usage(playerstruct * pl, object * target, char *argstring)
{
  int k;
  char temp1[30];

  if ((k = sscanf(argstring, "%15[^\n]", temp1)) < 1)
    {
      write_text(pl, "you need to specify a usage string");
      return;
    }
  set_obj_usage(temp1, target);
}

void
set_str(playerstruct * pl, object * target, char *argstring)
{
  int             k,
                  v1;
  
  if (!IS_ALIVE(target))
    {
      write_text(pl, "it is not alive you cannot set that!");
      return;
    }
  if ((k = sscanf(argstring, "%d", &v1)) < 1)
    {
      write_text(pl, "you need to specify a strength number");
      return;
    }
  SET_STR(target, v1);
}
void
set_color(playerstruct * pl, object * target, char *argstring)
{
  int             k,
                  v1;
  
  if ((k = sscanf(argstring, "%d", &v1)) < 1)
    {
      write_text(pl, "you need to specify a color number");
      return;
    }
  target->color = v1;
  SET_PL_ITEM_CHANGED(pl);
}

void
set_keynum(playerstruct * pl, object * target, char *argstring)
{
  int             k,
									v1;
  if (!IS_DOOR(target))
    {
      write_text(pl, "it is not a door, you cannot set that!");
      return;
    }
  if ((k = sscanf(argstring, "%d", &v1)) < 1)
    {
      write_text(pl, "you need to specify a key number");
      return;
    }
  target->data.docomp->keynum = v1;
}

void
set_state(playerstruct * pl, object * target, char *argstring)
{
  int             k,
                  v1,v2,v3;
  
  if ((k = sscanf(argstring, "%d %d %d", &v1,&v2,&v3)) < 1)
	{
	  write_text(pl, "you need to specify a state number");
	  return;
	}
  if (k > 2)
    target->state.aux = v3;
  if (k > 1)
    target->state.input = v2;
  
  target->state.normal = v1;

}

void
set_speed(playerstruct * pl, object * target, char *argstring)
{
  int k,
      v1;
  if ((k = sscanf(argstring, "%d", &v1)) < 1)
    {
      write_text(pl, "you need to specify a speed number");
      return;
	}
	SET_SPEED(target, v1);
}

void
set_picnum(playerstruct * pl, object * target, char *argstring)
{
  int k,
      v1;
  if ((k = sscanf(argstring, "%d", &v1)) < 1)
    {
      write_text(pl, "you need to specify a picture number");
      return;
    }
  SET_PIC(target, v1);
  SET_PL_ITEM_CHANGED(pl);
}

void set_obj_message (playerstruct *pl,object *target,char *argstring)
{
  if (strlen (argstring) < 1)
    {
      write_text (pl,"no message specified, freeing the current message");
      free_all_obj_messages (target);
    }
  else
    set_message (target,argstring);
}

void set_obj_channel (playerstruct *pl,object *target, char *argstring)
{
  char tmp_string[32];
  
  if ((sscanf(argstring,"%32s",tmp_string))<1)
    {
      write_text (pl,"no channel specified, freeing all channels");
      free_all_obj_channels (target);
    }
  else
    add_channel_to_obj (target,tmp_string);
}

void
set_weap_dam (playerstruct * pl, object * target, char *argstring)
{
  int k,
		  v1;
  
  if (!IS_WEAPON(target))
    {
      write_text (pl,"You cannot set weapon damage on a non weapon!");
      return;
    }
  
	if ((k = sscanf(argstring, "%d", &v1)) < 1)
	  {
	    write_text(pl, "you need to specify the amount of damage");
	    return;
	  }
  
  if ( target->owner == pl->obj
      && AN_OB_ITEM(pl->obj).held == target)
    {
      unequip_held (pl->obj);
      write_text (pl, "weapon unequipped to preserve integrity");
    }
  SET_WEAP_DAM(target, v1);
  SET_PL_ITEM_CHANGED(pl);
}

void
set_obj_val(playerstruct *pl,object *tmp, char *temp3,char *tempa)
{
  /* this needs a hash table BAD! */
  if (!strcmp(temp3, "dest"))
    set_dest(pl, tmp, tempa);
  else if (!strcmp(temp3, "name"))
    set_name(pl, tmp, tempa);
  else if (!strcmp(temp3, "statbits"))
    set_statbits(pl, tmp, tempa);
  else if (!strcmp(temp3,"material"))
    set_material(pl, tmp, tempa);
  else if (!strcmp(temp3,"resist"))
    set_resist(pl,tmp,tempa);
  else if (!strcmp(temp3,"usage"))
    set_usage(pl,tmp,tempa);
  else if (!strcmp(temp3,"bonus"))
    set_bonus(pl,tmp,tempa);
  else if (!strcmp(temp3, "str"))
    set_str(pl, tmp, tempa);
  else if (!strcmp(temp3, "key"))
    set_keynum (pl,tmp,tempa);
  else if (!strcmp(temp3, "speed"))
    set_str(pl, tmp, tempa);
  else if (!strcmp (temp3,  "state"))
    set_state(pl,tmp,tempa);
  else if (!strcmp(temp3, "picnum"))
    set_picnum(pl, tmp, tempa);
  else if (!strcmp(temp3, "weap_dam"))
    set_weap_dam (pl,tmp, tempa);
  else if (!strcmp(temp3, "message"))
    set_obj_message(pl,tmp,tempa);
  else if (!strcmp(temp3, "color"))
    set_color(pl,tmp,tempa);
  else if (!strcmp(temp3, "channel"))
    set_obj_channel(pl,tmp,tempa);
  else
    write_text(pl, "variable not supported");
}


