#include <standard.h>

/*this should actually use a tree structure*/
void
insert_key(playerstruct *pl,KeySym *key,int function)
{
	keystruct *tmp = (keystruct *) malloc (sizeof(keystruct));
	
	tmp->keysym = key;
	tmp->function = tmp;
	
	if (pl->keys == NULL)
	{
		pl->keys = tmp;
		tmp = NULL;
	}
	else
	{
		tmp->next = pl->keys;
		pl->keys = tmp;
	}
}

void set_key (playerstruct *pl,char *res_name,int function,char *default)
{
	char *tmp,
 			 tmpbuf[128];
	
	if (NO_RESOURCES(pl) ||
	(tmp = XGetDefault(pl->display,RES_NAME,res_name))==NULL)
		insert_key(pl,XStringToKeysym (default),function);
	else
		insert_key(pl,XStringToKeysym (tmp),function);
}
void
get_player_keys (playerstruct *pl)
{
 	tmp = XGetDefault (pl->display,RES_NAME,"resource_keys");
 	
 	if (strcmp(tmp,"true") || strcmp(tmp,"True")
 		SET_NO_RESOURCES(pl);
 	
 	set_key (pl,"move_f_key",move_f,"t");
 	set_key (pl,"move_fr_key",move_fr,"y");
 	set_key (pl,"move_fl_key",move_fl,"r");
 	set_key (pl,"move_l_key",move_l,"f");
 	set_key (pl,"move_r_key",move_r,"h");
 	set_key (pl,"move_b_key",move_b,"n");
 	set_key (pl,"move_bl_key",move_bl,"v");
 	set_key (pl,"move_br_key",move_br,"m");
 	set_key (pl,"turn_right_key",turn_right,"7");
 	set_key (pl,"turn_left_key",turn_left,"5");
 	set_key (pl,"pickup_key",pickup,",");
 	set_key (pl,"drop_key",drop,"/");
 	set_key (pl,"interact_mode_key",interact_mode,"i");
 	set_key (pl,"interact_key",interact,"I");
 	set_key (pl,"use_mode_key",use_mode,"u");
 	set_key (pl,"use_key",use_key,"U");
 	set_key (pl,"container_key",container,"c");
 	set_key (pl,"query_key",query,"?");
 	set_key (pl,"equip_key",equip,"e");
 	set_key (pl,"repeat_key",repeat,".");
 	set_key (pl,"parser_key",parser,"'");
 	set_key (pl,"aggressive_key",agressive,"a");
 	set_key (pl,"shift_left_key",shift_left,"k");
 	set_key (pl,"shift_right_key",shift_right,"l");
 	set_key (pl,"shift_up_key",shift_up,"<");
 	set_key (pl,"shift_down_key",shift_down,">");
 	/*set_key (pl,"",move_fl,"g");*/
}

	
void
apply_bstate(playerstruct * pl, int dir)
{
	object         *tobj;
	if (!OB_DIR_IN_MAP(pl->obj, (dir + pl->obj->facing) % 8))
		return;
	if ((dir < 2) || (dir > 6))
	{
		switch (pl->buttonstate)
		{
		case (1):

			/*
			 * tobj = TOP_MAP_OBJ(pl->obj->mapin, pl->obj->x +
			 * xdeltas[(int) (pl->obj->facing + dir) % 8],
			 * pl->obj->y + ydeltas[(int) (pl->obj->facing + dir)
			 * % 8], pl->obj->z);
			 */
			tobj = PL_ADJ_OBJ(pl, dir);
			SENDRQ(tobj, interact) (tobj, pl->obj);
			break;

		case (2):
			if (!PL_HAS_USED(pl))
			{
				tobj = AN_OB_ITEM(pl->obj).held;
				if (tobj != NULL)
				{
					SENDRQ(tobj, use) (tobj, pl->obj, PL_ADJ_OBJ(pl, dir), dir);
				} else
				{
					attack_object(PL_ADJ_OBJ(pl, dir), pl->obj, NULL);
				}
				SET_PL_HAS_USED(pl);
			}
			break;
		}
	} else
		switch (dir)
		{
		case (0):
		case (1):
		case (7):
			break;
		case (2):
		case (3):
			pl->obj->facing = (pl->obj->facing + 2) % 8;
			break;
		case (4):
			if (!PL_HAS_MOVED(pl))
			{
				move_object(pl->obj, (pl->obj->facing + 4) % 8);
				SET_PL_HAS_MOVED(pl);
			}
			break;
		case (5):
		case (6):
			pl->obj->facing = (pl->obj->facing + 6) % 8;
			break;
		default:
			fprintf(stderr, "direction range error in character");
			break;
		}
}

/******************************************/
/* reset_normal_controllers               */
/*   	reset_normal_controllers will set   */
/* the players control routines and       */
/* objects back to the default/normal     */
/* values. Objects that grab control      */
/* should use this routine. (must?)       */
/******************************************/
void
reset_normal_controllers(playerstruct * pl)
{
	/* reset the control objects */
	pl->key_object = pl->button_object = pl->obj;

	/* reset the handlers */
	pl->key_control = (&get_single_key);
	pl->button_control = (&get_simple_buttonpress);
	pl->parsing[0] = '\0';
}


/*******************************************/
/* parse_command                           */
/* 		parse_command will essentially pass  */
/* control to the appropriate command      */
/* driver. It does so by hashing the       */
/* command name on the input line and then */
/* searching the hash table for the command*/
/* entry which matches                     */
/*******************************************/
void
parse_command(playerstruct * pl)
{
	int             hashlock,
	                rehash;
	char            parsetemp[16];
	command        *ctemp;

	/* attempt parse only if player typed something */
	if (pl->parsing != '\0')
	{
		pl->key_object = pl->obj;
		sscanf(pl->parsing, "%16s", parsetemp);

		/* get hash and rehash values */
		hashlock = hash_name(parsetemp);
		rehash = hash_name2(parsetemp);

		/* search for matching rehash in the specified hash location */
		for (ctemp = commlist[hashlock]; (ctemp != NULL) && (ctemp->rehash != rehash);
		     ctemp = ctemp->next);

		/* execute command only if found a match in table */
		/* and it is legal for this player to execute    */
		if ((ctemp == NULL) || (IS_DM_COMMAND(ctemp) && !PL_HAS_DM_POWER(pl)))
			write_text(pl, "no such command...");
		else
			DO_COMM_CALLBACK(ctemp, pl);
	}
}

/**********************************/
/* get_single_key                 */
/* 		get_single_key will take a  */
/* single buttonpress event and   */
/* pass the data directly to the  */
/* current key object via the     */
/* recieve key request            */
/**********************************/
void
get_single_key(playerstruct * pl, XEvent event)
{
	char            tmpbuf[128];
	KeySym          key;
	XComposeStatus  compose;
	int             k;

	k = XLookupString(&event.xkey, tmpbuf, 10, &key, &compose);
	/* fprintf (stderr,"%s\n",XKeysymToString(key)); */
	SENDRQ(pl->key_object, recieve_keyboard) (pl->key_object, pl->obj, &key);
}

void
get_line(playerstruct * pl, XEvent event)
{
	char            tmpbuf[128];

	KeySym          key;
	XComposeStatus  compose;

	XLookupString(&event.xkey, tmpbuf, 10, &key, &compose);
	if (isascii(key))
	{
		if (pl->px < 255)
		{
			pl->parsing[pl->px++] = (char) key;
			write_parsing(pl);
		}
	} else
		switch (key)
		{
		case (XK_Return):
			pl->parsing[pl->px] = '\0';
			write_text(pl, pl->parsing);
			clear_parsing(pl);
			SENDRQ(pl->key_object, recieve_keyboard) (pl->key_object, pl->parsing);
			pl->px = 0;
			break;
		case (XK_Delete):
		case (XK_BackSpace):
		case (XK_Left):
			if (pl->px > 0)
			{
				pl->parsing[--pl->px] = '\0';
				clear_parsing(pl);
				write_parsing(pl);
			}
			break;
		default:
			break;
		}
}

void
decode_keycommand(playerstruct * pl, KeySym * key_point)
{
	char            tmpbuf[100];
	KeySym          key = *key_point;
	object *tmp;
	
	for (
	if (isascii(key))
	{
		switch (key)
		{
		case ('.'):
			write_text(pl, pl->parsing);
			parse_command(pl);
			break;
		case ('-'):
			write_text(pl, "moving up and down does not yet work");
			break;
		case ('+'):
			write_text(pl, "moving up and down does not yet work");
			break;
		case ('='):
			pl->obj->facing = (pl->obj->facing + 6) % 8;
			break;
		case ('*'):
			pl->obj->facing = (pl->obj->facing + 2) % 8;
			break;
		case ('?'):
			sprintf(tmpbuf, "X:%d  Y:%d  Z:%d", pl->obj->x, pl->obj->y, pl->obj->z);
			write_text(pl, tmpbuf);
			sprintf(tmpbuf, "facing: %s", dir_names[pl->obj->facing]);
			write_text(pl, tmpbuf);
			break;
		case ('['):
			shift_items_up(pl);
			break;
		case (']'):
			shift_items_down(pl);
			break;
		case ('{'):
			shift_items_left(pl);
			break;
		case ('}'):
			shift_items_right(pl);
			break;
		case ('\''):
			if (pl->itemmode == 1)
			{
 				if (pl->top_held == pl->obj->holding)
				{
					pickup_object(pl->obj, HEAD(pl->obj->below));
					pl->top_held = pl->obj->holding;
				} else
				{
					pickup_object(pl->obj, HEAD(pl->obj->below));
				}
			} else
				{
				tmp = pl->top_held->below;
				pickup_object(pl->obj, HEAD(pl->top_held));
				pl->top_held = tmp;
				}
			SET_PL_ITEM_CHANGED(pl);
			break;
		case ('`'):
			if (IS_EQUIPPED(pl->top_held))
				write_text(pl, "Unequip it Before attempting to Drop");
			else
				drop_object(pl->obj, pl->top_held);
			SET_PL_ITEM_CHANGED(pl);
			break;
		case ('i'):
			pl->buttonstate = 1;
			SET_PL_COMS_CHANGED(pl);
			break;
		case ('u'):
			pl->buttonstate = 2;
			SET_PL_COMS_CHANGED(pl);
			break;
		case ('E'):
			equip_object(pl->obj, pl->top_held);
			SET_PL_STATS_CHANGED(pl);
			SET_PL_ITEM_CHANGED(pl);
			break;
		case ('c'):
			write_text(pl, "Moving to Next Container Upwards");
			pl->itemmode--;
			if (pl->itemmode < 0)
			{
				pl->itemmode = 1;
				pl->top_held = pl->obj->holding;
			} else if (pl->itemmode == 0)
			{
				pl->top_held = pl->obj->below;
			} else
				pl->top_held = pl->top_held->owner;
			SET_PL_ITEM_CHANGED(pl);
			break;
		case ('a'):
			if (PL_CHARGES(pl))
			{
				CLEAR_PL_CHARGES(pl);
				write_text(pl, "No longer in charging mode");
			} else
			{
				SET_PL_CHARGES(pl);
				write_text(pl, "You are now in Charging mode");
				write_text(pl, "You will attack anything you run into");
				write_text(pl, "when you are holding a melee type weapon");
			}
			break;
		default:
			write_text(pl, "?");
			break;
		}
	} else
	{
		switch (key)
		{
		case (XK_Return):
			write_text(pl, "parser mode");
			pl->keystate = PARSE_STATE;
			pl->key_control = (&get_line);
			pl->px = 0;
			clear_parsing(pl);
			break;
		case (XK_Delete):
			write_text(pl, "repeating....");
			write_text(pl, pl->parsing);
			parse_command(pl);
			break;
		case (XK_Insert):
			pl->obj->facing = (pl->obj->facing + 6) % 8;
			break;
		case (XK_KP_Add):
			pl->obj->facing = (pl->obj->facing + 2) % 8;
			break;
		case (XK_F27):
			move_player(pl, pl->obj->facing);
			break;
		case (XK_Up):
			move_player(pl, (pl->obj->facing + 1) % 8);
			break;
		case (XK_F29):
			move_player(pl, (pl->obj->facing + 2) % 8);
			break;
		case (XK_Right):
			move_player(pl, (pl->obj->facing + 3) % 8);
			break;
		case (XK_F35):
			move_player(pl, (pl->obj->facing + 4) % 8);
			break;
		case (XK_Down):
			move_player(pl, (pl->obj->facing + 5) % 8);
			break;
		case (XK_R13):
			move_player(pl, (pl->obj->facing + 6) % 8);
			break;
		case (XK_Left):
			move_player(pl, (pl->obj->facing + 7) % 8);
			break;
		case (XK_R4):
			pl->obj->facing = (pl->obj->facing + 6) % 8;
			break;
		case (XK_R6):
			pl->obj->facing = (pl->obj->facing + 2) % 8;
			break;
		case (XK_KP_7):
			apply_bstate(pl, 0);
			break;
		case (XK_KP_8):
			apply_bstate(pl, 1);
			break;
		case (XK_KP_9):
			apply_bstate(pl, 2);
			break;
		case (XK_KP_6):
			apply_bstate(pl, 3);
			break;
		case (XK_KP_3):
			apply_bstate(pl, 4);
			break;
		case (XK_KP_2):
			apply_bstate(pl, 5);
			break;
		case (XK_KP_1):
			apply_bstate(pl, 6);
			break;
		case (XK_KP_4):
			apply_bstate(pl, 7);
			break;
		default:
			break;
		}
	}
}
void
get_simple_buttonpress(playerstruct * pl, XEvent event)
{
	SENDRQ(pl->button_object, recieve_button) (pl->button_object, pl->obj, &event.xbutton.window, &event.xbutton.button, &event.xbutton.x, &event.xbutton.y);
}

void
get_no_buttonpress(playerstruct * pl, XEvent event)
{
	return;
}

void
handle_button(playerstruct * pl, XEvent event)
{
}
