/*********************************************************/
/* file: resmotif.c                                      */
/*                                                       */
/* Copyright (C) 1994 Karl A Holland                     */
/*                                                       */
/* author: Karl A Holland                                */
/*                                                       */
/* created:   1 sept 93                                  */
/*                                                       */
/* modified:  7 february 94                              */
/*                                                       */
/* contributing authors:                                 */
/*  if you add place your name here or below             */
/*                                                       */
/* description:                                          */
/*  resmotif is one of the c source files for resedit,   */
/* the resource editor program. remsmotif encapsulates   */
/* many of the calls to MOTIF.                           */
/*                                                       */
/* LICENSING:                                            */
/*   a full license  is provided in the file LICENSE     */
/* which should have been included with this program when*/
/* it was copied. It may be found in the top directory   */
/* of any NORMAL distribution, named LICENSE             */
/*********************************************************/
#include <resedit.h> 

Widget
CreateHSlider(Widget parent, char *name,int min,int max,char *title,
	      int show_val,int show_title,
	      XtCallbackProc callback,XtPointer client_data)
{
  Widget hslider;
  Arg    args[20];
  int    n;
  XmString tstring;

  n=0;

  XtSetArg(args[n], XmNorientation,XmHORIZONTAL);
  n++;
  
  XtSetArg(args[n],XmNprocessingDirection,XmMAX_ON_RIGHT);
  n++;

  XtSetArg(args[n],XmNmaximum,max);
  n++;
  
  XtSetArg(args[n],XmNminimum,min);
  n++;

  XtSetArg(args[n],XmNshowValue, show_val);
  n++;
  
  tstring = XmStringCreateSimple(title);
  
  XtSetArg(args[n],XmNtitleString,tstring);
  n++;
  
  hslider = XmCreateScale(parent,name,args,n);

  XmStringFree(tstring);
  
  XtAddCallback(hslider,XmNvalueChangedCallback,callback,client_data);

  XtManageChild (hslider);
  
  return hslider;
}

Widget
CreateVSlider(Widget parent, char *name,int min,int max,char *title,
	      int show_val,int show_title,
	      XtCallbackProc callback,XtPointer client_data)
{
  Widget hslider;
  Arg    args[20];
  int    n;
  XmString tstring;

  n=0;

  XtSetArg(args[n], XmNorientation,XmVERTICAL);
  n++;
  
  XtSetArg(args[n],XmNprocessingDirection,XmMAX_ON_BOTTOM);
  n++;

  XtSetArg(args[n],XmNmaximum,max);
  n++;
  
  XtSetArg(args[n],XmNminimum,min);
  n++;

  XtSetArg(args[n],XmNshowValue, show_val);
  n++;
  
  tstring = XmStringCreateSimple(title);
  
  XtSetArg(args[n],XmNtitleString,tstring);
  n++;
  
  hslider = XmCreateScale(parent,name,args,n);

  XmStringFree(tstring);
  
  XtAddCallback(hslider,XmNvalueChangedCallback,callback,client_data);

  XtManageChild (hslider);
  
  return hslider;
}    
Widget
CreateDrawingArea(Widget parent,char *name,XtCallbackProc callback,
     XtPointer client_data)
{
  Widget          drawarea;
  Arg             args[20];
  int             n;

  n = 0;

  drawarea = XmCreateDrawingArea(parent, name, args, n);

  XtAddCallback(drawarea, XmNexposeCallback, callback, client_data);

  XtManageChild(drawarea);

  return drawarea;

}

Widget
CreatePopupMenu(Widget parent,char*name)
{
  Widget  cascade,menuwidget;
  Arg  args[20];
  int  n;
  

  n = 0;
  
  /* not quite sure how to make the popup window... */
  menuwidget = XmCreatePulldownMenu(parent,name,args,n);

  n = 0;

  XtSetArg(args[n],XmNsubMenuId,menuwidget);
  n++;

  XtSetArg(args[n],XmNpopupEnabled,True);
  n++;

  cascade = XmCreateCascadeButton(parent,name,args,n);
  
  XtManageChild(cascade);
  return menuwidget;
}


Widget
CreatePushButton(Widget parent,char *name,XtCallbackProc callback,
     XtPointer client_data)
{
  Widget          button;
  Arg             args[20];
  int             n;

  n = 0;

  XtSetArg(args[n], XmNdefaultButtonShadowThickness, 0);
  n++;

  button = XmCreatePushButton(parent, name, args, n);

  XtAddCallback(button, XmNactivateCallback, callback, client_data);

  XtManageChild(button);

  return button;

}

Widget
CreateSeparatorV (Widget parent, char * name)
{
  Widget          sep;
  Arg             args[20];
  int             n;

  n = 0;
  
  XtSetArg(args[n],XmNorientation,XmVERTICAL);
  n++;
  
  XtSetArg(args[n],XmNseparatorType,XmSHADOW_ETCHED_IN);
  n++;
  
  sep = XmCreateSeparator(parent,name,args,n);
  
  XtManageChild (sep);
  
  return sep;
}

Widget
CreateSeparatorH (Widget parent, char * name)
{
  Widget          sep;
  Arg             args[20];
  int             n;

  n = 0;
  
  XtSetArg(args[n],XmNorientation,XmHORIZONTAL);
  n++;
  
  XtSetArg(args[n],XmNseparatorType,XmSHADOW_ETCHED_IN);
  n++;
  
  sep = XmCreateSeparator(parent,name,args,n);
  
  XtManageChild (sep);
  
  return sep;
}


Widget
CreateRowColH(Widget parent, char *name)
{
  Widget          rowcol;
  Arg             args[20];
  int             n;

  n = 0;

  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);
  n++;
  
  XtSetArg(args[n], XmNspacing,2);
  n++;
  
  XtSetArg(args[n], XmNadjustLast, True);
  n++;

  XtSetArg(args[n], XmNresizeHeight,True);
  n++;
  
  XtSetArg(args[n], XmNresizeWidth,True);
  n++;
  /*
  XtSetArg(args[n], XmNpacking, XmPACK_TIGHT);
  n++;
*/
  rowcol = XmCreateRowColumn(parent, name, args, n);

  XtManageChild(rowcol);

  return rowcol;

}

Widget
CreateRowColV(Widget parent, char *name)

{
  Widget          rowcol;
  Arg             args[20];
  int             n;

  n = 0;

  XtSetArg(args[n], XmNorientation, XmVERTICAL);
  n++;
  
  XtSetArg(args[n], XmNspacing,2);
  n++;
  
  XtSetArg(args[n], XmNresizeHeight,True);
  n++;
  
  XtSetArg(args[n], XmNresizeWidth,True);
  n++;
  
  XtSetArg(args[n], XmNadjustLast, True);
  n++;

  XtSetArg(args[n], XmNpacking, XmPACK_TIGHT);
  n++;

  rowcol = XmCreateRowColumn(parent, name, args, n);

  XtManageChild(rowcol);

  return rowcol;

}

Widget
CreateFrame(Widget parent, char *name)
{
  Widget          frame;
  Arg             args[20];
  int             n;

  n = 0;

  frame = XmCreateFrame(parent, name, args, n);

  XtManageChild(frame);


  return frame;

}

Widget
CreateList(Widget parent,
     char *name,
     XtCallbackProc callback,
     XtCallbackProc activator,
     XtPointer client_data)
{
  Widget          list;
  Arg             args[20];
  int             n;

  n = 0;

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);
  n++;

  XtSetArg(args[n], XmNlistSizePolicy, XmVARIABLE);
  n++; 

  XtSetArg(args[n], XmNvisibleItemCount, 20);
  n++;
  
  XtSetArg(args[n], XmNselectionPolicy, XmSINGLE_SELECT);
  n++;
  
  list = XmCreateScrolledList(parent, name, args, n);

  XtManageChild(list);

  XtAddCallback(list, XmNsingleSelectionCallback, callback, client_data);
 
  XtAddCallback(list, XmNdefaultActionCallback, activator, client_data);
 
  return list;

}

Widget
CreateForm(Widget parent,
     char *name)
{

  Widget          form;
  Arg             args[20];
  int             n;

  n = 0;

  form = XmCreateForm(parent, name, args, n);
  XtManageChild(form);
  return form;

}

Widget
CreateBB(Widget parent,char *name)
{
  Widget  bb;
  Arg     args[20];
  int     n;
  n=0;
  bb = XmCreateBulletinBoard(parent,name,args,n);
  XtManageChild(bb);
  return bb;
}

Widget
CreateLabel(Widget parent, char *name, char *string)
{
  Widget label;
  Arg    args[20];
  int    n;
  XmString label_string;

  label_string = XmStringCreateSimple (string);
  
  n = 0;
  
  XtSetArg (args[n],XmNlabelString,label_string);
  n++;

  label = XmCreateLabel(parent,name,args,n);

  XmStringFree(label_string);
  
  XtManageChild (label);
  
  return label;
}

Widget
CreateLineText(Widget parent,char *name,
	       XtCallbackProc callback, XtPointer client_data)
{
  Widget text;
  Arg    args[20];
  int    n;
  
  n = 0;
  
  XtSetArg (args[n],XmNeditMode,XmSINGLE_LINE_EDIT);
  n++;

  text = XmCreateText(parent,name,args,n);

  XtAddCallback(text,XmNvalueChangedCallback,callback,client_data);

  XtManageChild(text);
  return text;
}

Widget
CreateMainWindow(Widget parent,
     int x,
     int y,
     int width,
     int height,
     char *name)
{

  Widget          mainwindow;
  Arg             args[20];
  int             n;

  n = 0;

  XtSetArg(args[n], XmNmappedWhenManaged, True);
  n++;

  XtSetArg(args[n], XmNx, x);
  n++;

  XtSetArg(args[n], XmNy, y);
  n++;

  XtSetArg(args[n], XmNwidth, width);
  n++;

  XtSetArg(args[n], XmNheight, height);
  n++;

  mainwindow = XmCreateMainWindow(parent, name, args, n);

  return mainwindow;

}

Widget
CreateCommand(Widget parent,
        int x,
        int y,
        int width,
        int height,
        char *name)
{
  Widget          pane;
  int             n = 0;
  Arg             args[20];

  XtSetArg(args[n], XmNx, x);
  n++;

  XtSetArg(args[n], XmNy, y);
  n++;

  XtSetArg(args[n], XmNwidth, width);
  n++;

  XtSetArg(args[n], XmNheight, height);
  n++;

  pane = XmCreateCommand(parent, name, args, n);

  XtManageChild(pane);

  return pane;
}

Widget
CreatePane(Widget parent,
     int x,
     int y,
     int width,
     int height,
     char *name)
{
  Widget          command;
  int             n = 0;
  Arg             args[20];

  XtSetArg(args[n], XmNx, x);
  n++;

  XtSetArg(args[n], XmNy, y);
  n++;

  XtSetArg(args[n], XmNwidth, width);
  n++;

  XtSetArg(args[n], XmNheight, height);
  n++;

  command = XmCreatePanedWindow(parent, name, args, n);

  XtManageChild(command);

  return command;
}

void
SetMainAreas(Widget mainwindow, Widget menubar, Widget workarea, Widget command)
{
  XmMainWindowSetAreas(mainwindow, menubar, command, (Widget) NULL,
           (Widget) NULL, workarea);

  XtManageChild(mainwindow);
}

void
attach_all_position (Widget item, int top_pos, int bottom_pos,
			 int left_pos, int right_pos)
{
  Arg             args[20];
  int             n = 0;
  
  /*set hard %'age  positions */
  
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);
  n++;
  XtSetArg(args[n],XmNtopPosition,top_pos);
  n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);
  n++;
  XtSetArg(args[n],XmNbottomPosition,bottom_pos);
  n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);
  n++;
  XtSetArg(args[n],XmNleftPosition,left_pos);
  n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION);
  n++; 
  XtSetArg(args[n],XmNrightPosition,right_pos);
  n++;
  XtSetValues(item,args,n);
   
}

void
attach_spec_position (Widget item,int position, int pos_value)
{
  Arg             args[20];
  int             n = 0;
  
  /*set hard %'age  positions */
 
  switch (position)
    {
    case (top_position):
      XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);
      n++;
      XtSetArg(args[n],XmNtopPosition,pos_value);
      n++;  
      break;
    case (bottom_position):
      XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);
      n++;
      XtSetArg(args[n],XmNbottomPosition,pos_value);
      n++;  
      break;
    case (left_position):
      XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);
      n++;
      XtSetArg(args[n],XmNleftPosition,pos_value);
      n++;  
      break;
    case (right_position):
      XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION);
      n++;
      XtSetArg(args[n],XmNrightPosition,pos_value);
      n++;  
      break;
    default:
      return;
      break;
    }
  
  XtSetValues(item,args,n); 
}

void
attach_spec_form (Widget item,int position)
{
  Arg             args[20];
  int             n = 0;
  
  /*set form position */
  
  switch (position)
    {
    case (top_position):
      XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);
      n++;
      break;
    case (bottom_position):
      XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);
      n++;
      break;
    case (left_position):
      XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);
      n++;
      break;
    case (right_position):
      XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);
      n++;
      break;
    default:
      return;
      break;
    }
  XtSetValues(item,args,n); 
}

void
attach_spec_widget (Widget item,int position, Widget to_item)
{
  Arg             args[20];
  int             n = 0;

  switch (position)
    {
    case (top_position): 
      XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET);
      n++;
      XtSetArg(args[n],XmNtopWidget,to_item);
      n++;
      break;
    case (bottom_position):
      XtSetArg(args[n],XmNbottomAttachment,XmATTACH_WIDGET);
      n++;
      XtSetArg(args[n],XmNbottomWidget,to_item);
      n++;
      break;
    case (left_position):
      XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET);
      n++;
      XtSetArg(args[n],XmNleftWidget,to_item);
      n++;
      break;
    case (right_position):
      XtSetArg(args[n],XmNrightAttachment,XmATTACH_WIDGET);
      n++;
      XtSetArg(args[n],XmNrightWidget,to_item);
      n++;
      break;
    default:
      return;
      break;
    }
  XtSetValues(item,args,n); 
}
void
attach_spec_opposite (Widget item,int position, Widget to_item)
{
  Arg             args[20];
  int             n = 0;

  switch (position)
    {
    case (top_position): 
      XtSetArg(args[n],XmNtopAttachment,XmATTACH_OPPOSITE_WIDGET);
      n++;
      XtSetArg(args[n],XmNtopWidget,to_item);
      n++;
      break;
    case (bottom_position):
      XtSetArg(args[n],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);
      n++;
      XtSetArg(args[n],XmNbottomWidget,to_item);
      n++;
      break;
    case (left_position):
      XtSetArg(args[n],XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);
      n++;
      XtSetArg(args[n],XmNleftWidget,to_item);
      n++;
      break;
    case (right_position):
      XtSetArg(args[n],XmNrightAttachment,XmATTACH_OPPOSITE_WIDGET);
      n++;
      XtSetArg(args[n],XmNrightWidget,to_item);
      n++;
      break;
    default:
      return;
      break;
    }
  XtSetValues(item,args,n); 
}

void
SetLabel (Widget label_widget, char *new_label)
{
  Arg args[20];
  int n;
  XmString tstring;
  n = 0;

  tstring = XmStringCreateSimple(new_label);

  XtSetArg(args[n],XmNlabelString,tstring);
  n++;

  XtSetValues (label_widget,args,n);
  
  XmStringFree (tstring);
}
